DECLARE FUNCTION PEEKL& (lAddr&)
DECLARE SUB POKEL (lAddr&, lValue&)
DECLARE SUB ReadBlock (iFile AS INTEGER, iBlock AS INTEGER)
DECLARE SUB ReadBlock16 (iFile AS INTEGER, iBlock AS INTEGER)
DECLARE SUB sbDetect ()
DECLARE SUB sbDma8AutoInit (lLength AS LONG)
DECLARE SUB sbFrequency (lFrequency AS LONG)
DECLARE SUB sbIntAck8 ()
DECLARE SUB sbMixerReset ()
DECLARE SUB sbMixerStereo (iStereo AS INTEGER)
DECLARE SUB sbReset ()
DECLARE SUB sbSpeakerOn (iOn AS INTEGER)
DECLARE SUB sbWait ()
DECLARE SUB SetDma (lAudioSeg AS LONG, lAudioPtr AS LONG, lLength AS LONG)
DECLARE SUB SetDmaNotify (pwSeg AS LONG, pwPtr AS LONG, iUseEvent AS INTEGER)
DECLARE FUNCTION u& (iNum AS INTEGER)

DEFSTR A-Z:  DEFDBL D:  DEFINT I:  DEFSNG F: DEFLNG L: DEFSTR S

REM $INCLUDE: 'AudioSB.bi'

CONST SoundBufferSize = 1024 '512,1024,2048 or 4096
CONST SoundBufferSize2 = SoundBufferSize * 2
CONST SoundBufferPages = SoundBufferSize \ 256
TYPE StreamBuffer
  part0 AS STRING * SoundBufferSize
  part1 AS STRING * SoundBufferSize
  part2 AS STRING * SoundBufferSize
  part3 AS STRING * SoundBufferSize
END TYPE

COMMON SHARED tBuff AS StreamBuffer
DIM SHARED iSbPort AS INTEGER, iSbIrq AS INTEGER, iSbDma AS INTEGER
DIM SHARED lSndLen AS LONG, lSndFreq AS LONG
DIM SHARED lsr(6)  AS LONG, l16to8(6) AS LONG
DIM SHARED iInit AS INTEGER, iUpdateFlag AS INTEGER, iUpdateStatus AS INTEGER
DIM SHARED iBasePart AS INTEGER, iBlock AS INTEGER, iBlksLeft  AS INTEGER
DIM SHARED lAudioSeg AS LONG, lAudioPtr AS LONG

REM REM $INCLUDE: 'DbgWav.bas'

REM $DYNAMIC
FUNCTION PEEKL& (lAddr)
  lTemp = PEEK(lAddr) OR PEEK(lAddr + 1) * &H100& OR PEEK(lAddr + 2) * &H10000
  iVal = PEEK(lAddr + 3)
  IF iVal > 127 THEN
    lTemp = lTemp OR (&H1000000 * (iVal XOR &H80))
    lTemp = lTemp XOR &H80000000
  ELSE
    lTemp = lTemp + &H1000000 * u(iVal)
  END IF
  PEEKL = lTemp
END FUNCTION

DEFSNG A-E, G-K, M-Z
SUB POKEL (lAddr AS LONG, lValue AS LONG)
 POKE lAddr + 0, lValue AND 255
 lValue = ((lValue AND &HFFFFFF00) \ 256&) AND &HFFFFFF
 POKE lAddr + 1, lValue AND 255: lValue = lValue \ 256&
 POKE lAddr + 2, lValue AND 255: lValue = lValue \ 256&
 POKE lAddr + 3, lValue AND 255
END SUB

DEFINT I
DEFSTR S
SUB ReadBlock (iFile AS INTEGER, iBlock AS INTEGER)
  lSeek = SEEK(iFile) - 1&: IF lSeek > tWave.lLof THEN lSeek = tWave.lLof
  lEnd = tWave.lLof - (lSeek + SoundBufferSize)
  
  SELECT CASE iBasePart + (iBlock AND 1)
  CASE 0
    IF lSeek < tWave.lLof THEN GET #iFile, , tBuff.part0
    IF lEnd < 0 THEN MID$(tBuff.part0, 1 + SoundBufferSize + lEnd) = STRING$(-lEnd, 128)
  CASE 1
    IF lSeek < tWave.lLof THEN GET #iFile, , tBuff.part1
    IF lEnd < 0 THEN MID$(tBuff.part1, 1 + SoundBufferSize + lEnd) = STRING$(-lEnd, 128)
  CASE 2
    IF lSeek < tWave.lLof THEN GET #iFile, , tBuff.part2
    IF lEnd < 0 THEN MID$(tBuff.part2, 1 + SoundBufferSize + lEnd) = STRING$(-lEnd, 128)
  CASE 3
    IF lSeek < tWave.lLof THEN GET #iFile, , tBuff.part3
    IF lEnd < 0 THEN MID$(tBuff.part3, 1 + SoundBufferSize + lEnd) = STRING$(-lEnd, 128)
  END SELECT
END SUB

SUB ReadBlock16 (iFile AS INTEGER, iBlock AS INTEGER)
  STATIC sBlock AS STRING * SoundBufferSize2
  lSeek = SEEK(iFile) - 1&: IF lSeek > tWave.lLof THEN lSeek = tWave.lLof
  lEnd = tWave.lLof - (lSeek + SoundBufferSize2)
  IF lSeek < tWave.lLof THEN GET #iFile, , sBlock
  DEF SEG = VARSEG(sBlock):  lPtr = VARPTR(sBlock)

  iLimit = SoundBufferSize
  IF lEnd < 0 THEN lEnd = lEnd \ 2: iLimit = iLimit + lEnd
  IF iLimit > SoundBufferSize THEN PRINT "bad limit": EXIT SUB
  FOR iC = 0 TO iLimit - 1
    POKE lPtr + iC, (PEEK(lPtr + iC + iC + 1) + 128)
  NEXT iC
  FOR iC = iLimit TO SoundBufferSize - 1
    POKE lPtr + iC, 128
  NEXT iC

  SELECT CASE iBasePart + (iBlock AND 1)
  CASE 0: tBuff.part0 = sBlock
  CASE 1: tBuff.part1 = sBlock
  CASE 2: tBuff.part2 = sBlock
  CASE 3: tBuff.part3 = sBlock
  END SELECT

  'SELECT CASE iBasePart + (iBlock AND 1)
  'CASE 0: CALL absolute(sBlock, tBuff.Part0, VARPTR(l16to8(0)))
  'CASE 1: CALL absolute(sBlock, tBuff.Part1, VARPTR(l16to8(0)))
  'CASE 2: CALL absolute(sBlock, tBuff.Part2, VARPTR(l16to8(0)))
  'CASE 3: CALL absolute(sBlock, tBuff.Part3, VARPTR(l16to8(0)))
  'END SELECT



END SUB

DEFSNG I, L, S
SUB sbDetect

  DIM sBlast AS STRING
  DIM iPosi AS INTEGER
  DIM iChar AS INTEGER

  sBlast = ENVIRON$("BLASTER")

  IF LEN(sBlast) = 0 THEN
    PRINT "BLASTER environment variable not set..."
    PRINT "Assuming A220 I7 D1 T0"
    iSbPort = &H220: iSbIrq = 7: iSbDma = 1
    EXIT SUB
  END IF
  
  DO
    iPosi = INSTR(sBlast, "A")
    IF iPosi = 0 OR iPosi > LEN(sBlast) - 3 THEN iPosi = 0: EXIT DO
    iChar = ASC(MID$(sBlast, iPosi + 1))
    IF iChar < ASC("1") OR iChar > ASC("9") THEN iPosi = 0: EXIT DO
    IF ASC(MID$(sBlast, iPosi + 3)) <> ASC("0") THEN iPosi = 0: EXIT DO
    iSbPort = VAL("&h" + MID$(sBlast, iPosi + 1, 3))

    iPosi = INSTR(sBlast, "I")
    IF iPosi = 0 OR iPosi > LEN(sBlast) - 1 THEN iPosi = 0: EXIT DO
    iChar = ASC(MID$(sBlast, iPosi + 1))
    IF iChar < ASC("1") OR iChar > ASC("9") THEN iPosi = 0: EXIT DO
    iSbIrq = VAL(MID$(sBlast, iPosi + 1, 2))

    iPosi = INSTR(sBlast, "D")
    IF iPosi = 0 OR iPosi > LEN(sBlast) - 1 THEN iPosi = 0: EXIT DO
    iChar = ASC(MID$(sBlast, iPosi + 1))
    IF iChar < ASC("0") OR iChar > ASC("9") THEN iPosi = 0: EXIT DO
    iSbDma = VAL(MID$(sBlast, iPosi + 1, 2))

    EXIT DO
  LOOP

  IF iPosi = 0 THEN
    PRINT "BLASTER environment is INVALID..."
    PRINT "Assuming A220 I7 D1 T0"
    iSbPort = &H220: iSbIrq = 7: iSbDma = 1
    EXIT SUB
  END IF
  
  'IF POS(0) > 1 THEN PRINT
  'PRINT "PORT=" + HEX$(iSbPort) + " IRQ=" + LTRIM$(STR$(iSbIrq)) + " DMA=" + LTRIM$(STR$(iSbDma));

END SUB

SUB sbDma8AutoInit (lLength AS LONG)
  lLen = (lLength - 1)
  sbWait
  OUT iSbPort + &HC, &H48
  sbWait
  OUT iSbPort + &HC, (lLen AND 255)
  sbWait
  OUT iSbPort + &HC, ((lLen \ 256) AND 255)
  sbWait
  OUT iSbPort + &HC, &H1C
END SUB

SUB sbFrequency (lFrequency AS LONG)
 
  lFreq = 65536 - (256000000 \ (1 * lFrequency))
  sbWait
  OUT iSbPort + &HC, &H40
  OUT iSbPort + &HC, (lFreq \ 256) AND 255

END SUB

SUB sbIntAck8
  DIM iResu AS INTEGER
  iResu = INP(iSbPort + &HE)
END SUB

DEFLNG U
SUB sbMixerReset
  sbWait
  OUT iSbPort + &H4, &H0
  sbWait
  OUT iSbPort + &H5, &HFF
END SUB

SUB sbMixerStereo (iStereo AS INTEGER)
  : sbWait: OUT iSbPort + &H4, &HE
  IF iStereo THEN
    : sbWait: OUT iSbPort + &H5, &H22
  ELSE
    : sbWait: OUT iSbPort + &H5, &H20
  END IF
END SUB

DEFSNG U
SUB sbOut (iSample AS INTEGER)

  OUT iSbPort + &HC, &H10
  OUT iSbPort + &HC, iSample

END SUB

SUB sbReset

 OUT iSbPort + &H6, 1
 WAIT &H3DA, 8
 OUT iSbPort + &H6, 0
 
 DIM sTimeout AS SINGLE
 sTimeout = TIMER
 DO
   IF INP(iSbPort + &HE) THEN
     IF INP(iSbPort + &HA) = &HAA THEN
       iInit = 1: EXIT DO
     END IF
   END IF
   IF ABS(TIMER - sTimeout) > .5 THEN
     iInit = 0: EXIT DO
   END IF
 LOOP

END SUB

SUB sbSpeakerOn (iOn AS INTEGER)

  sbWait
  IF iOn THEN
    OUT iSbPort + &HC, &HD1
  ELSE
    OUT iSbPort + &HC, &HD3
  END IF

END SUB

SUB sbWait

  WAIT iSbPort + &HC, 128, 128

END SUB

DEFINT I
DEFLNG L
SUB SetDma (lAudioSeg AS LONG, lAudioPtr AS LONG, lLength AS LONG)

  DEF SEG = lAudioSeg
  iA = PEEK(lAudioPtr) <> 128
  iB = PEEK(lAudioPtr + u(SoundBufferSize)) <> 128
  IF iA OR iB THEN
    PRINT "Wrong buffer location"
  END IF

  lAddr = lAudioSeg * 16& + lAudioPtr
  lPage = lAddr \ 65536
  lAddr = lAddr AND &HFFFF&
  
  lLent = (lLength) - 1

  iSbDma2 = iSbDma + iSbDma
  OUT &HA, 4 + iSbDma
  OUT &HC, 0
  OUT &HB, &H58 + iSbDma
  
  OUT &HC, &H0
  OUT iSbDma2, (lAddr AND 255)
  OUT iSbDma2, ((lAddr \ 256) AND 255)
 
  OUT &HC, &H0
  OUT iSbDma2 + 1, (lLent AND 255)
  OUT iSbDma2 + 1, ((lLent \ 256) AND 255)

  SELECT CASE iSbDma
  CASE 0: OUT &H87, lPage
  CASE 1: OUT &H83, lPage
  CASE 2: OUT &H81, lPage
  CASE 3: OUT &H82, lPage
  END SELECT

  OUT &HA, iSbDma

END SUB

DEFDBL D
DEFSTR A-C, E-H, J-K, M-Z
SUB SetDmaNotify (pwSeg AS LONG, pwPtr AS LONG, iUseEvent AS INTEGER) STATIC
  
  DIM lOldSegPtr AS LONG, lNewIsr AS LONG
  DIM set(9) AS LONG, rst(5) AS LONG
  IntNum = 8 + iSbIrq
  IntMask = CINT(2 ^ (iSbIrq AND 7))

  DEF SEG = &H30
  IF PEEK(0) = ASC("@") AND PEEK(1) = ASC("x") THEN lOldSegPtr = PEEKL(2)
 
  IF pwSeg = 0 AND pwPtr = 0 THEN
    IF lOldSegPtr = 0 THEN EXIT SUB
    ' *** Restoring Old ISR ***
    IF rst(0) = 0 THEN
      rst(0) = &HEC8B60FA               'cli / pusha / mov bp,sp
      rst(1) = &H145E8B1E               'push ds / mov bx,[bp+14]
      rst(2) = &H25B417C5               'lds dx,[bx] / mov ah,25h
      rst(3) = &H21CD08B0 + iSbIrq * 256 'mov al,0Fh / int 21h
      rst(4) = &H90FB611F               'pop ds / popa
      rst(5) = &H2CA                    'retf 0002h
    END IF

    OUT &H21, INP(&H21) OR IntMask
    IF lOldSegPtr THEN
      DEF SEG = VARSEG(rst(0))
      CALL absolute(lOldSegPtr, VARPTR(rst(0)))
      lOldSegPtr = 0
      DEF SEG = &H30:  FOR iN = 0 TO 63: POKE iN, 0: NEXT
    END IF

  ELSE

    OUT &H21, INP(&H21) OR IntMask
    IF lOldSegPtr = 0 THEN
      DEF SEG = &H30: POKE 0, ASC("@"): POKE 1, ASC("x")
      IF iUseEvent THEN
        REM UEVENT ON:  ON UEVENT GOSUB EventISR
        ' *** Create ISR code for events ***
        REM DIM iSeg AS INTEGER, iOff AS INTEGER
        REM lPev = AddrOfSetUEvent 'lib call to get ptr for qb internal func
        lPev = 0
        IF lPev = 0 THEN PRINT "addr of SetUEvent failed...": END
        lSeg = (((lPev AND &HFFFF0000) \ &H10000) AND &HFFFF&)
        lOff = (lPev AND &HFFFF&)
        'PRINT HEX$(lSeg) + ":" + HEX$(lOff)
        lSeg = lSeg * 256&: lOff = lOff * 256&
        lsr(0) = &H90000068 + lSeg 'push 0000h  / nop
        lsr(1) = &H60000068 + lOff 'push 0000h  / pusha
        lsr(2) = &H5EFFEC8B        'mov bp,sp / call far [bp+10h]
        lsr(3) = &HE620B010        'mov al,20 / out 20,al
        lsr(4) = &HC4836120        'popa / add sp, 4
        lsr(5) = &HCF04            'iret
      ELSE
        ' *** Create ISR code ***
        lsr(0) = &H681E60FA          'cli / pusha / push ds / ...
        lsr(1) = pwSeg + &H681F0000  'push 0000h / pop ds / ...
        lsr(2) = pwPtr + &HFE5B0000  'push 0000h / pop bx / ...
        lsr(3) = &H1F20B007          'inc [bx] / mov al,20h / pop ds
        lsr(4) = &HFB6120E6          'out 20,al / popa / sti
        lsr(5) = &HCF                'iret
      END IF

   
      ' *** Set New ISR ***
      IF set(0) = 0 THEN
        set(0) = &H60EC8B55                 'push bp / mov bp,sp / pusha
        set(1) = &H3508B806 + iSbIrq * 65536 'push es / mov ax,350Fh
        set(2) = &HC28C21CD                 'int 21h / mov dx,es
        set(3) = &H8768B07                  'pop es / mov si,[bp+08]
        set(4) = &H1E025489                 'mov [si+02],dx / push ds
        set(5) = &H25B41C89                 'mov [si],bx / mov ah,25
        set(6) = &HFA065E8B                 'mov bx,[bp+06] / cli
        set(7) = &H21CD17C5                 'lds dx,[bx] / int 21h
        set(8) = &H905D611F                 'pop ds / popa / pop bp
        set(9) = &H2CAFB                    'sti / retf 0002h
      END IF
   
      DEF SEG = &H30: lNewIsr = 8
      FOR iN = 0 TO 5:  POKEL lNewIsr + iN * 4, lsr(iN):  NEXT iN

      'lN = VARSEG(lsr(0))
      'IF lN = &H8000 THEN lN = -2147483647 ELSE lN = (lN * 65536) + 1
      'lNewIsr = lN + u(VARPTR(lsr(0))) - 1

      lNewIsr = &H300008
      DEF SEG = VARSEG(set(0))
      CALL absolute(lOldSegPtr, lNewIsr, VARPTR(set(0)))
      DEF SEG = &H30:  POKEL 2, lOldSegPtr:  POKE 6, 0: POKE 7, 0

    END IF
    OUT &H21, INP(&H21) AND ((NOT IntMask) AND 255)
   
  END IF
  ERASE set: ERASE rst

END SUB

DEFSNG F
SUB SoundDeInit
  SoundStopWav
  IF iInit THEN
    IF iInit = 2 THEN UEVENT OFF
    DEF SEG = &H30: IF PEEK(6) THEN POKE 6, 0: POKE 7, 0: sbIntAck8
    'IF iUpdateFlag THEN iUpdateFlag = 0: sbIntAck8
    SetDmaNotify 0, 0, 0
    sbSpeakerOn 0
    : sbReset: iInit = 0
  END IF
END SUB

FUNCTION SoundInit% (iUseEvent AS INTEGER)
  
  'code to convert 16bit samples to 8bit
  'l16to8(0) = &HDC8B071E 'push ds | pop es | mov bx,sp
  'l16to8(1) = &H8B06778B 'mov si,[bx+06]
  'l16to8(2) = &H748B047F 'mov di,[bx+04] | mov si,[si+02]
  'l16to8(3) = &H27D8B02  'mov di,[di+02]
  'l16to8(4) = &H460000B9 'mov cx,0?00 | inc si | lodsw
  'l16to8(5) = &HAA8004AD 'add al,80 | stosb
  'l16to8(6) = &H4CAFAE2  'loop #-3 | retf 4
  'l16to8(4) = l16to8(4) + (SoundBufferPages * 65536)

  lAudioSeg = u((VARSEG(tBuff.part0)))
  lAudioPtr = u((VARPTR(tBuff.part0)))
  lChk = lAudioSeg * 16 + lAudioPtr
  iBasePart = ((lChk AND &HFFFF) > (65535 - SoundBufferSize2)) AND 2
  IF iBasePart THEN lAudioPtr = lAudioPtr + SoundBufferSize2
  'PRINT "Base Part: "; iBasePart

  sbDetect
  sbReset
  IF iInit = 0 THEN
    IF POS(0) > 1 THEN PRINT
    COLOR 12: PRINT "Failed to init Sound Blaster": COLOR 7
    SoundInit = 0: EXIT FUNCTION
  END IF

  'SetDmaNotify u(VARSEG(iUpdateFlag)), u(VARPTR(iUpdateFlag))
  SetDmaNotify &H30, &H6, iUseEvent
  IF iUseEvent THEN SoundInit = 2 ELSE SoundInit = 1
  

END FUNCTION

SUB SoundPlayWav (sFile AS STRING)
  iFN = FREEFILE: iSuccess = 0
  REM ON LOCAL ERROR GOTO failed
  OPEN sFile FOR INPUT AS #iFN
  CLOSE #iFN: iSuccess = 1
failed:
  IF iSuccess = 0 THEN
    IF POS(0) > 1 THEN PRINT
    COLOR 12: PRINT "Failed to open "; sFile: COLOR 7
    EXIT SUB
  END IF
  REM ON LOCAL ERROR GOTO 0

  IF tWave.iFN THEN SoundStopWav

  OPEN sFile FOR BINARY ACCESS READ AS #iFN
  sHeader = INPUT$(512, iFN): sHDR = UCASE$(sHeader)
  iPos = 0
  IF LEFT$(sHDR, 4) = "RIFF" THEN
    iPos = INSTR(sHDR, "FMT ")
    IF iPos THEN
      GET #iFN, iPos + 8, tWave
      IF tWave.wCh < 1 OR tWave.wCh > 2 THEN iPos = 0
      IF tWave.lHz < 2000 OR tWave.lHz > 44100 THEN iPos = 0
      IF tWave.wAg <> ((tWave.wCh * tWave.wBits) \ 8) THEN iPos = 0
      IF tWave.lSz <> (tWave.wAg * tWave.lHz) THEN iPos = 0
      IF tWave.wBits < 8 OR tWave.wBits > 16 THEN iPos = 0
    END IF
    IF iPos THEN
      iPos = INSTR(sHDR, "DATA")
      IF iPos THEN iPos = iPos + 4
    END IF

  END IF
  sHeader = "": sHDR = ""
  IF iPos = 0 THEN
    IF POS(0) > 1 THEN PRINT
    COLOR 12: PRINT "Bad WAV file...": COLOR 7
    CLOSE #tWave.iFN: tWave.iFN = 0
    EXIT SUB
  END IF

  GET #iFN, iPos, tWave.lLof: iPos = iPos + 4
  tWave.lLof = tWave.lLof AND (NOT ((tWave.wCh * tWave.wBits \ 8) - 1))
  tWave.lLof = tWave.lLof + iPos'LOF(iFN)
  IF tWave.lLof > LOF(iFN) THEN tWave.lLof = LOF(iFN)

  lSndFreq = tWave.lHz * tWave.wCh
  lSndLen = (tWave.lLof - iPos) \ (tWave.wBits \ 8)
  tWave.iLeft = (lSndLen + (SoundBufferSize - 1)) \ SoundBufferSize
  tWave.lSz = lSndLen:  tWave.lSec = lSndFreq * tWave.wCh
  tWave.lCnt = 0:  tWave.iFN = iFN: tWave.iSeek = iPos

  tBuff.part0 = STRING$(SoundBufferSize, 128)
  tBuff.part1 = STRING$(SoundBufferSize, 128)
  tBuff.part2 = STRING$(SoundBufferSize, 128)
  tBuff.part3 = STRING$(SoundBufferSize, 128)
  SetDma lAudioSeg, lAudioPtr, (SoundBufferSize2)

  IF tWave.wCh = 2 THEN
    sbMixerReset
    sbMixerStereo 1
  END IF
  sbSpeakerOn 1

  DEF SEG = &H30: POKE 6, 0: POKE 7, 0
  iUpdateStatus = 1
  sbFrequency lSndFreq

  iBlock = 0: iBlksLeft = tWave.iLeft
  IF tWave.wBits = 8 THEN ReadBlock tWave.iFN, iBlock ELSE ReadBlock16 iFN, iBlock
  iBlock = iBlock XOR 1: iBlksLeft = iBlksLeft - 1
  IF iBlksLeft THEN
    IF tWave.wBits = 8 THEN ReadBlock tWave.iFN, iBlock ELSE ReadBlock16 iFN, iBlock
    iBlock = iBlock XOR 1: iBlksLeft = iBlksLeft - 1
  END IF

  sbDma8AutoInit SoundBufferSize


END SUB

REM $STATIC
FUNCTION SoundStatus%
  SoundStatus = iUpdateStatus
END FUNCTION

REM $DYNAMIC
SUB SoundStopWav
  IF tWave.iFN THEN
    CLOSE #tWave.iFN: tWave.iFN = 0
    sbReset
  END IF
END SUB

FUNCTION SoundUpdate% (iEvent AS INTEGER)
  'get playing block
  SoundUpdate% = 0
  IF tWave.iFN = 0 THEN EXIT FUNCTION
  'iCurBlk = INP(iSbDma + iSbDma + 1) 'we dont care for the low byte
  'iCurBlk = (INP(iSbDma + iSbDma + 1) \ SoundBufferPages)
  DEF SEG = &H30: IF PEEK(6) = 0 THEN SoundUpdate% = 1: EXIT FUNCTION
  'IF iUpdateFlag = 0 THEN SoundUpdate% = 1: EXIT FUNCTION
  DO 'while iUpdateFlag > 0
    DEF SEG = &H30:  IF PEEK(6) = 0 THEN EXIT DO
    POKE 6, PEEK(6) - 1: sbIntAck8
    tWave.lCnt = tWave.lCnt + SoundBufferSize
    IF tWave.lCnt > tWave.lSz THEN tWave.lCnt = tWave.lSz
    IF iBlksLeft < 0 THEN SoundStopWav: EXIT FUNCTION
    IF tWave.wBits = 8 THEN ReadBlock tWave.iFN, iBlock ELSE ReadBlock16 tWave.iFN, iBlock
    iBlock = iBlock XOR 1: iBlksLeft = iBlksLeft - 1
  LOOP
  SoundUpdate% = 2
  
END FUNCTION

DEFLNG U
DEFSNG A-E, G-T, V-Z
FUNCTION u (iNum AS INTEGER)
  uu = CLNG(iNum) AND &HFFFF&
  u = uu
END FUNCTION

